* itsp 4.4 - 4.7

clear
use ex_employee, clear
generate byte beginspell = employer != employer[_n-1]
list, sepby(employer) noobs

generate byte beginunemp = missing(employer) & ((employer != employer[_n-1]) | (_n == 1))
list if beginunemp, sep(0)

generate spellnr = sum(beginspell)
list, sepby(employer) noobs

bysort spellnr: egen meanwage = mean(wage)
format meanwage %5.2f
list, sep(0) noobs

sort spellnr
by spellnr: gen length = _N if !missing(employer)
generate byte longspell = (length >= 3 & !missing(length))
list year employer length longspell, sepby(employer) noobs

save ch44,replace


use ch45, clear
// rename family fam
// drop nadult-oldestsibling
list fam person female age, sepby(fam) noobs

drop nadult nchild sibs nboys nbros older oldestchild oldestsibling
sort fam
by fam: egen nadult = total(age >= 18)
by fam: egen nchild = total(age <= 17) if age <= 17
generate sibs = nchild - 1 
by fam: egen nboys = total(age <= 17 & !female) if age <= 17

by fam: egen nbros = total(age <= 17 & !female) if age <= 17
replace nbros = nbros - (age <= 17 & !female)


sort fam (age)
by fam: g older = (age <= 17 & age[_n+1] <= 17) * (age < age[_n+1])

by fam: egen oldestchild = max(age) if age<=17
g oldestsibling = cond(age < oldestchild & age <= 17, oldestchild, .)

list fam female age nadult sibs nboys nbros older oldestsibling, sepby(fam) noobs
save ch45,replace

use gdp4cty, clear
keep cty gdp date
levelsof cty, local(gdplist)
reshape wide gdp, i(date) j(cty) string
describe
foreach c of local gdplist {
	local allcty "`allcty' gdp`c'"
}

foreach c of local allcty {
	local allbut: list allcty - c
	qui regress `c' `allbut' date
	display _newline "Dependent variable `c':"
	mat list e(b)
}

/*
qui levelsof ctycode if gdp < ., local(gdplist)
qui levelsof ctycode if pop < ., local(poplist)
local allcty: list gdplist | poplist
local allcty: list sort allcty
display _n "All ctycodes represented: `allcty'"
local bothcty: list gdplist & poplist
local bothcty: list sort bothcty
display _n "Ctycodes in both lists: `bothcty'"

bysort ctycode (pop): replace gdp = gdp[_N]
drop if missing(pop)
*/

/*
generate gdpobs = cond(gdp < ., _n, .)
summarize gdpobs, meanonly
local obs `r(min)'
foreach c of local bothcty {
	local elt: list posof "`c'" in poplist
	qui replace gdp = gdp[`obs'] in `elt'
	local obs = `obs' + 1
}
keep if missing(gdpobs)
drop gdpobs
*/

/* 
list, noobs sep(0)
*/

local date `c(current_date)'
local time `c(current_time)'
local vers `c(stata_version)'
local mem  `c(memory)'
local flav = cond(`c(MP)', "MP", cond(`c(SE)', "SE", "IC"))
local cwd `c(pwd)'

display _newline "Run `date' at `time' on Stata/`flav' version `vers', memory = `mem' bytes"
display _newline "Current working directory: `cwd'"

sysuse auto, clear
display _newline "Datafile: `c(filename)' (N=`c(N)', k=`c(k)')  as of `c(filedate)'"


