
* ITSP 6.6 - 

use air2, clear
* put a time-series calendar on the data
tsmktim ym, start(1949m1)
* get the month number
generate mnr = month(dofm(ym))
* find the end-of-quarter months
generate eoq = (mod(mnr, 3) == 0)
list ym mnr eoq air in 1/16, sep(4) noobs

// keep only last month of quarter
preserve
keep if eoq
tsmktim yq, start(1949q1)
list yq air in 1/16, sep(4) noobs

// sum the values over the quarter
restore, preserve
generate qtr = qofd(dofm(ym))
format qtr %tq
collapse (sum) airsum=air, by(qtr)
tsmktim yq, start(1949q1)
list yq airsum in 1/16, sep(4) noobs


// average the values over the quarter
restore, preserve
generate qtr = qofd(dofm(ym))
format qtr %tq
collapse airavg=air, by(qtr)
tsmktim yq, start(1949q1)
list yq airavg in 1/16, sep(4) noobs


restore
tsset ym
tscollap (last) aireoq=air (sum) airsum=air (mean) airavg=air, to(q) gen(yq)
list in 1/16, sep(4) noobs
